import { FieldProps } from 'formik';
import React, { useCallback, useMemo, FunctionComponent } from 'react';

import { Fieldset, FormField, Label, Legend, TextInput } from '../ui/form';

const BillingOrderComments: FunctionComponent = () => {
    const renderLabel = useCallback(name => (
        <Label hidden htmlFor={ name }>P.O. Number (Optional)</Label>
    ), []);

    const renderInput = useCallback(({ field }: FieldProps) => (
        <TextInput
            { ...field }
            autoComplete={ 'off' }
            maxLength={ 2000 }
        />
    ), []);

    const legend = useMemo(() => (
        <Legend>P.O. Number (Optional)</Legend>
    ), []);

    return <Fieldset legend={ legend } testId="checkout-shipping-comments">
        <FormField
            input={ renderInput }
            label={ renderLabel }
            name="orderComment"
        />
    </Fieldset>;
};

export default BillingOrderComments;
